package yrpg.bamp.basedata.webapi;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.openapi.api.result.ApiSaveItemData;
import kd.bos.openapi.api.result.ApiSaveResult;
import kd.bos.openapi.api.result.BaseFilterItemData;
import kd.bos.openapi.api.result.BaseFilterResult;
import kd.bos.openapi.api.result.ApiSaveRowErrorData ;
import kd.bos.openapi.common.custom.annotation.ApiController;
import kd.bos.openapi.common.custom.annotation.ApiParam;
import kd.bos.openapi.common.custom.annotation.ApiPostMapping;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.openapi.common.result.OpenApiResult;
import kd.bos.openapi.common.util.OpenApiSdkUtil;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.util.StringUtils;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

@ApiController(value="CommonBill",desc="统一url入口")
public class CostCenterApiController {
	//存放实际地址和接口入口的
	@ApiPostMapping(value="costCenterURLApiHandler")
	public CustomApiResult<Object> costCenterApiHandler(@Valid  @ApiParam("入口参数") CostCenterApiReqModel reqModel) {
		//获取入参
		String reqdata=reqModel.getData();
		JSONArray dataArray = JSONObject.parseArray(reqdata);

		//获取系统现有成本中心数据
		DynamicObjectCollection costcenters = QueryServiceHelper.query("bos_costcenter", "number,yrpg_mainid,enable", new QFilter[]{});
		Map<String,String> costcenterStatusMap = new HashMap<String,String>();
		Map<String,String> costcenterNumMap = new HashMap<String,String>();
		for (DynamicObject costcenter : costcenters){
			costcenterStatusMap.put(costcenter.getString("yrpg_mainid"),costcenter.getString("enable"));
			costcenterNumMap.put(costcenter.getString("number"),costcenter.getString("yrpg_mainid"));
		}
		//参数重新组装成 新增（修改）、启用（解封）、禁用（封存）参数
		JSONArray costcenterData = new JSONArray();
		JSONArray freezeNums = new JSONArray();
		JSONArray unfreezeNums = new JSONArray();

		JSONObject saveDataJson = new JSONObject();
		JSONObject freezeDataJson = new JSONObject();
		JSONObject unfreezeDataJson = new JSONObject();

		JSONObject freezeNumsJson = new JSONObject();
		JSONObject unfreezeNumsJson = new JSONObject();
		//循环判断部门进入保存、封存、解封集合
		for(int i=0;i<dataArray.size();i++){
			JSONObject jsonObject = dataArray.getJSONObject(i);
			String number = jsonObject.getString("yrpg_mainid");
			boolean isfreeze = jsonObject.getBoolean("isfreeze");
			//根据入参是否封存，已经系统中状态判断
			if(costcenterStatusMap.get(number)==null){
				costcenterData.add(jsonObject);
			}else if(!isfreeze&&costcenterStatusMap.get(number).equals("1")){
				costcenterData.add(jsonObject);
			}else if(costcenterStatusMap.get(number).equals("1")&&isfreeze){
				freezeNums.add(number);
			}else if(costcenterStatusMap.get(number).equals("0")&&!isfreeze){
				unfreezeNums.add(number);
			}
		}

		//返回值
		BaseFilterResult responseData = new BaseFilterResult();
		CustomApiResult finalResult =new CustomApiResult();
		//判断是否调用禁用启用
		boolean isfreeze = false;
		//调用禁用接口
		if(freezeNums.size()>0){
			isfreeze = true;
			freezeNumsJson.put("yrpg_mainids",freezeNums);
			freezeDataJson.put("data",freezeNumsJson);
			//调用接口
			OpenApiResult adminfreeze = OpenApiSdkUtil.invoke("/v2/yrpg/basedata/bos_costcenter/costcenterDisable", freezeDataJson, new HashMap<>());
			BaseFilterResult data = (BaseFilterResult)adminfreeze.getData();
			List<BaseFilterItemData> result = data.getResult();
			for(BaseFilterItemData item : result){
				String number = item.getNumber();
				if(!StringUtils.isEmpty(number)){
					item.setNumber(costcenterNumMap.get(number));
				}
			}
			responseData = data;
		}
		//调用解封接口
		if(unfreezeNums.size()>0){
			isfreeze = true;
			unfreezeNumsJson.put("yrpg_mainids",unfreezeNums);
			unfreezeDataJson.put("data",unfreezeNumsJson);
			//调用接口
			OpenApiResult unfreezeResult = OpenApiSdkUtil.invoke("/v2/yrpg/basedata/bos_costcenter/costcenterEnable", unfreezeDataJson, new HashMap<>());
			BaseFilterResult data = (BaseFilterResult)unfreezeResult.getData();
			List<BaseFilterItemData> result = data.getResult();
			for(BaseFilterItemData item : result){
				String number = item.getNumber();
				if(StringUtils.isEmpty(number)){
					item.setNumber(costcenterNumMap.get(number));
				}
			}
			if(responseData==null){
				responseData = data;
			}else{
				BaseFilterResult basefilterResult = (BaseFilterResult)responseData;
				long failCount = data.getFailCount();
				long successCount = data.getSuccessCount();
				long totalCount = data.getTotalCount();
				//接口重新合计
				basefilterResult.setFailCount(failCount+basefilterResult.getFailCount());
				basefilterResult.setSuccessCount(basefilterResult.getSuccessCount()+successCount);
				basefilterResult.setTotalCount(basefilterResult.getTotalCount()+totalCount);
				basefilterResult.getResult().addAll(data.getResult());
			}
		}
		//调用保存接口
		if(costcenterData.size()>0){
			saveDataJson.put("data",costcenterData);
			//调用接口
			OpenApiResult adminsave = OpenApiSdkUtil.invoke("/v2/yrpg/basedata/bos_costcenter/costcenterSave", saveDataJson, new HashMap<>());
			ApiSaveResult data = (ApiSaveResult)adminsave.getData();
			//根据查询更新操作返回值结构，将保存返回值组装
			List<ApiSaveItemData> result = data.getResult();
			for(ApiSaveItemData item:result){
				BaseFilterItemData baseFilterItemData = new BaseFilterItemData();
				baseFilterItemData.setNumber(item.getNumber());
				//报错时重新设置编码
				baseFilterItemData.setNumber(item.getKeys().get("yrpg_mainid"));
//				if(StringUtils.isEmpty(baseFilterItemData.getNumber())){
//				}
				baseFilterItemData.setId(item.getId());
				//组装错误信息
				List<ApiSaveRowErrorData> errors = item.getErrors();
				List<String> curerrors = new ArrayList<String>();
				for(ApiSaveRowErrorData errer:errors){
					StringBuffer sb = new StringBuffer();
					Set<String> rowMsg = errer.getRowMsg();
					for(String err:rowMsg){
						sb = sb.append(err);
					}
					curerrors.add(sb.toString());
				}
				baseFilterItemData.setErrors(curerrors);
				//根据错误信息判断状态
				if(errors.size()>0){
					baseFilterItemData.setBillStatus(false);
				}else{
					baseFilterItemData.setBillStatus(true);
				}
				responseData.getResult().add(baseFilterItemData);
			}
			long failCount = data.getFailCount();
			long successCount = data.getSuccessCount();
			//重新设置合计数
			if(isfreeze){
				responseData.setTotalCount(responseData.getTotalCount()+failCount+successCount);
				responseData.setSuccessCount(responseData.getSuccessCount()+successCount);
				responseData.setFailCount(responseData.getFailCount()+failCount);
			}else{
				responseData.setTotalCount(failCount+successCount);
				responseData.setSuccessCount(successCount);
				responseData.setFailCount(failCount);
			}
		}
		//多类型接口 过滤默认为空
		responseData.setFilter("");
		finalResult.setData(responseData);
		return finalResult;
	}


}